VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MyCls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Base 1
'  !!!!!!!
Option Explicit

Private FileS As String         '    ?
Private SectionArr() As Sect    '    ?

'  
Private Type KeyI
    NameK As String     '    
    ValueK As String    '  
End Type

'  ?
Private Type Sect
    NameS As String     '  
    ValuesS() As KeyI   '  ... 
End Type


'     ?    ?
Private Function FileReal(Path As String) As Boolean
'   :
' FileReal = Len(Dir(Path))
'      
' ..       
    If Dir(Path) = "" Then
        FileReal = False
    Else
        FileReal = True
    End If
End Function

'   ,   ?
Public Sub MakeFileIni(Path As String, Optional ReMake As Boolean)
    '       True  False  False c False???
    '   : If Not FileReal(Path)  Then
    '      
    If FileReal(Path) = False Then
        ' ..   ... 
        Open Path For Output As #1
        Close #1
    Else
        '  : If ReMake Then
        If ReMake = True Then
            '   ... ...
            Kill Path
            Open Path For Output As #1
            Close #1
        End If
    End If
    FileS = Path
    ' 
    ' )    ?
    ' )   ,    ,      ?
    LoadIni (Path)
End Sub

' ..  ?
Public Sub AddSection(SectionName As String)
    '     ?      FreeFile?
    Open FileS For Append As #2
        Print #2, "[" & SectionName & "]"
        Print #2, "IniKey=1"    '      ,    ?
    Close #2
    ' 
    ' )      ?
    ' )      ?
    '              ?
    LoadIni (FileS)
End Sub

'  
Private Sub LoadIni(Path As String)
'    :
'        
'    ,   
'    
'      ,   ...  . .
Dim Str As String
Dim Index As Integer
Dim IndexKey As Integer
Dim NameSect As String
Dim NameKey As String
Dim ValueKey As String


    Open Path For Input As #1
        Do While Not EOF(1)
            Line Input #1, Str
            '    $    ,   ,  ?
            If Mid$(Str, 1, 1) = "[" Then
                '     ?
                Index = Index + 1
                '     ,  
                ReDim Preserve SectionArr(Index)
                SectionArr(Index).NameS = Mid(Str, 2, Len(Str) - 2)
                IndexKey = 0
            Else
                '  If Len(Str) Then
                '    If StrPtr(Str) Then
                If Str <> "" Then
                    '     InStr(1, Str, "=")???
                    If InStr(1, Str, "=") <> 0 Then
                        '       NameKey  ValueKey ?      
                        NameKey = Mid(Str, 1, InStr(1, Str, "=") - 1)   ' Left   
                        ValueKey = Mid(Str, InStr(1, Str, "=") + 1)
                        IndexKey = IndexKey + 1
                        '   With SectionArr(Index).ValuesS(IndexKey)
                        '      
                        With SectionArr(Index)
                            '         
                            ReDim Preserve .ValuesS(IndexKey)
                            .ValuesS(IndexKey).NameK = NameKey
                            .ValuesS(IndexKey).ValueK = ValueKey
                        End With
                    End If
                End If
            End If
        Loop
    Close #1
End Sub

'     .
Public Sub AddKeyInSection(Section As String, Key As String, ValKey As String)
Dim KeyIndexReDim As Integer
Dim i As Long
    '      LBound   1,           
    '     ,        
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            ' ,          ?
            KeyIndexReDim = (UBound(SectionArr(i).ValuesS) + 1)
            ReDim Preserve SectionArr(i).ValuesS(KeyIndexReDim)
            '    with 
            SectionArr(i).ValuesS(KeyIndexReDim).NameK = Key
            SectionArr(i).ValuesS(KeyIndexReDim).ValueK = ValKey
        End If
    Next i
    '  
    WriteToIni (FileS)
    ' !!!!!!??????
    '         ,   ?
    '  WriteToIni     
    LoadIni (FileS)
End Sub

'   
Private Sub WriteToIni(Path As String)
Dim i As Long, t As Long    '     t     ,    , 
    Open Path For Output As #1
        '      
        For i = LBound(SectionArr) To UBound(SectionArr)
            '       "[","]","="   
            Print #1, "[" & SectionArr(i).NameS & "]"
            ' 
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                Print #1, SectionArr(i).ValuesS(t).NameK & "=" & SectionArr(i).ValuesS(t).ValueK
            Next t
        Next i
    Close #1
End Sub

'   
Public Sub DeleteSection(Section As String)
'         ?
'   ANDLL  www.vbstreets.ru
'   
'     ,   
'      ,    
'    ,         
' .        
Dim VirtualSection() As Sect
Dim Index As Integer
Dim i As Long, t As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
            If SectionArr(i).NameS <> Section Then
                Index = Index + 1
                ' , , ....        
                '  ??????
                ReDim Preserve VirtualSection(Index)
                '   ,      ,   ?
                '     ,      
                ReDim Preserve VirtualSection(Index).ValuesS(t)
                With VirtualSection(Index)
                    .NameS = SectionArr(i).NameS
                    .ValuesS(t).NameK = SectionArr(i).ValuesS(t).NameK
                    .ValuesS(t).ValueK = SectionArr(i).ValuesS(t).ValueK
                End With
            End If
        Next t
    Next i
    SectionArr = VirtualSection
    '         
    WriteToIni (FileS)
    '     
    LoadIni (FileS)
End Sub

'     
Public Sub DeleteKeyFromSection(Section As String, Key As String)
' ,     
'   ,       
'         
Dim VirtualSection() As Sect
Dim Index As Integer
Dim IndexS As Integer
Dim i As Long, t As Long
  
    For i = LBound(SectionArr) To UBound(SectionArr)
        Index = 0
        If SectionArr(i).NameS = Section Then
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                If SectionArr(i).ValuesS(t).NameK <> Key Then
                    Index = Index + 1
                    ReDim Preserve VirtualSection(i)
                    ReDim Preserve VirtualSection(i).ValuesS(Index)
                    With VirtualSection(i)
                        .NameS = SectionArr(i).NameS
                        .ValuesS(t).NameK = SectionArr(i).ValuesS(t).NameK
                        .ValuesS(t).ValueK = SectionArr(i).ValuesS(t).ValueK
                    End With
                End If
            Next t
        Else
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                ReDim Preserve VirtualSection(i)
                ReDim Preserve VirtualSection(i).ValuesS(t)
                With VirtualSection(i)
                    .NameS = SectionArr(i).NameS
                    .ValuesS(t).NameK = SectionArr(i).ValuesS(t).NameK
                    .ValuesS(t).ValueK = SectionArr(i).ValuesS(t).ValueK
                End With
            Next t
        End If
    Next i
    
    SectionArr = VirtualSection
    '         
    WriteToIni (FileS)
    '     
    LoadIni (FileS)
End Sub

'   
Public Sub ClearSection(Section As String)
Dim i As Long, t As Long
    '  ,  ...
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            ' 
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                ' ,   iniKey ...  ?    ?
                '    ,        
                If SectionArr(i).ValuesS(t).NameK <> "inikey" Then
                    ReDim Preserve SectionArr(i).ValuesS(1)
                    Exit For
                End If
            Next t
        End If
    Next i
    
    '         
    WriteToIni (FileS)
    '     
    LoadIni (FileS)
End Sub

'  
Public Sub RenameSection(Section As String, NewNameSection As String)
Dim i As Long
    '         
    '        
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            SectionArr(i).NameS = NewNameSection
            '        
        End If
    Next i
        
    '         
    WriteToIni (FileS)
    '     
    LoadIni (FileS)
End Sub

'  
Public Sub RenameKeyInSection(Section As String, Key As String, NewNameKey As String)
Dim i As Long, t As Long
    ' ,     
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                If SectionArr(i).ValuesS(t).NameK = Key Then
                    SectionArr(i).ValuesS(t).NameK = NewNameKey
                    '        
                End If
            Next t
            '        
        End If
    Next i
    
    '         
    WriteToIni (FileS)
    '     
    LoadIni (FileS)
End Sub

'   ?      ?
Public Sub RenameValueKeyInSection(Section As String, Key As String, NewValue As String)
Dim i As Long, t As Long
    ' ,     
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                If SectionArr(i).ValuesS(t).NameK = Key Then
                    SectionArr(i).ValuesS(t).ValueK = NewValue
                    '        
                End If
            Next t
            '        
        End If
    Next i
    
    '         
    WriteToIni (FileS)
    '     
    LoadIni (FileS)
End Sub

'  
Public Property Get SectionCount() As Long
    '  ,   
    SectionCount = UBound(SectionArr)
End Property

'    
Public Property Get CounKeyInSection(Section As String) As Long
'    Count?
Dim i As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            CounKeyInSection = UBound(SectionArr(i).ValuesS) - 1
        End If
    Next
End Property

Public Property Get GetKeyValueFromSection(Section As String, Key As String) As String
Dim i As Long, t As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                If SectionArr(i).ValuesS(t).NameK = Key Then
                    GetKeyValueFromSection = SectionArr(i).ValuesS(t).ValueK
                    '        
                End If
            Next t
            '        
        End If
    Next i
End Property

' ..    ini-?
Public Property Let FileIniPath(Path As String)
    '    ?
    FileS = Path
    LoadIni (Path)
End Property

'    ini-
'    
Public Property Get FileIniPath() As String
    FileIniPath = FileS
End Property

'    
Public Property Get GetAllNameSectionNumber() As String
Dim i As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        '    vbCrLf  ?     ?
        GetAllNameSectionNumber = GetAllNameSectionNumber & i & "-" & SectionArr(i).NameS & " ; "
    Next i
End Property

'     
Public Property Get GetAllNameValueKeyInSectionNumber(Section As String) As String
Dim i As Long, t As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                '     ,    
                GetAllNameValueKeyInSectionNumber = GetAllNameValueKeyInSectionNumber & t & "." & SectionArr(i).ValuesS(t).NameK & "=" & SectionArr(i).ValuesS(t).ValueK & "; "
            Next t
            '        /
        End If
    Next i
End Property

'    
Public Property Get GetNameSection(Number As Long) As String
    ' -...    1,    ?
    GetNameSection = SectionArr(Number).NameS
End Property

'          
Public Property Get GetNameValueKeyNumber(NumberSection As Long, NumberKey As Long) As String
    '        
    '      -   ,   
    GetNameValueKeyNumber = SectionArr(NumberSection).ValuesS(NumberKey).NameK & "=" & SectionArr(NumberSection).ValuesS(NumberKey).ValueK
End Property

'       
Public Property Get GetValueKeyName(Section As String, NameKey As String) As String
Dim i As Long, t As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                If SectionArr(i).ValuesS(t).NameK = NameKey Then
                    GetValueKeyName = SectionArr(i).ValuesS(t).ValueK
                    '        
                End If
            Next t
        End If
    Next i
End Property

'   (    ???)    ?
Public Property Get GetValueKey(NameKey As String) As String
Dim i As Long, t As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
            If SectionArr(i).ValuesS(t).NameK = NameKey Then
                GetValueKey = SectionArr(i).ValuesS(t).ValueK
                '        
            End If
        Next t
    Next i
End Property

'   
Public Property Get RealKey(Key As String) As Boolean
Dim i As Long, t As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
            If SectionArr(i).ValuesS(t).NameK = Key Then
                RealKey = True
                '        
            End If
        Next t
    Next i
End Property

'      
Public Property Get RealKeyInSection(Key As String, Section As String) As Boolean
Dim i As Long, t As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
                If SectionArr(i).ValuesS(t).NameK = Key Then
                    RealKeyInSection = True
                    '        
                End If
            Next t
        End If
    Next i
End Property

'   
Public Property Get RealSection(Section As String) As Boolean
Dim i As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        If SectionArr(i).NameS = Section Then
            RealSection = True
            '        
        End If
    Next i
End Property

'     (   ?   , )
Public Property Get CountAllKey() As Long
Dim i As Long, t As Long
    For i = LBound(SectionArr) To UBound(SectionArr)
        For t = LBound(SectionArr(i).ValuesS) To UBound(SectionArr(i).ValuesS)
            CountAllKey = CountAllKey + 1
        Next t
    Next i
End Property
